local MogIt,mog = ...;
_G["MogIt"] = mog;

mog.LDB = LibStub("LibDataBroker-1.1");
mog.LDBI = LibStub("LibDBIcon-1.0");
mog.mmb = mog.LDB:NewDataObject(MogIt,{
	type = "launcher",
	icon = "Interface\\Icons\\INV_Enchant_EssenceCosmicGreater",
	OnClick = function(self,btn)
		if mog.frame:IsShown() then
			HideUIPanel(mog.frame);
		else
			ShowUIPanel(mog.frame);
		end
	end,
	OnTooltipShow = function(self)
		if not self or not self.AddLine then return end
		self:AddLine("MogIt");
		self:AddLine("Click to open MogIt.",1,1,1);
	end
});

mog.db = {};
mog.addons = {};
mog.labels = {};
mog.count = 0;
mog.filters = {
	display = {},
	lvl = {},
	faction = {},
	class = {},
};

function mog.register(addon,label)
	if not mog.addons[addon] then
		mog.addons[addon] = {};
	end
	mog.count = mog.count + 1;
	mog.db[mog.count] = {};
	table.insert(mog.addons[addon],mog.count);
	mog.labels[mog.count] = label;
	return mog.count;
end

function mog.add(category,id,display,lvl,faction,class)
	table.insert(mog.db[category],id);
	mog.filters.display[id] = display;
	mog.filters.lvl[id] = lvl or 0;
	mog.filters.faction[id] = faction;
	mog.filters.class[id] = class;
end

mog.frame = CreateFrame("Frame","MogItFrame",UIParent,"ButtonFrameTemplate");
mog.frame:SetScript("OnEvent",function(self,event,arg1,...)
	if event == "PLAYER_LOGIN" then
		MogIt_Settings = MogIt_Settings or {
			tt = true,
			mouse = true,
			ttDress = false,
			guiDress = false,
			rotate = true,
			mog = true,
		};
		mog.settings = MogIt_Settings;
		mog.settings.minimap = mog.settings.minimap or {};
		mog.settings.ttWidth = mog.settings.ttWidth or 300;
		mog.settings.ttHeight = mog.settings.ttHeight or 300;
		mog.settings.guiWidth = mog.settings.guiWidth or 200;
		mog.settings.guiHeight = mog.settings.guiHeight or 200;
		mog.settings.rows = mog.settings.rows or 2;
		mog.settings.columns = mog.settings.columns or 3;
		
		MogIt_Wishlist = MogIt_Wishlist or {};
		mog.wishlist = MogIt_Wishlist;
		mog.wishlist.item = mog.wishlist.item or {};
		mog.wishlist.display = mog.wishlist.display or {};
		mog.wishlist.time = mog.wishlist.time or {};
		
		mog.updateGUI();
		mog.manip.model:SetUnit("PLAYER");
		mog.tooltip.model:SetUnit("PLAYER");
		if mog.settings.rotate then
			mog.tooltip.rotate:Show();
		end
		mog.tooltip:SetWidth(mog.settings.ttWidth);
		mog.tooltip:SetHeight(mog.settings.ttHeight);
		
		for i=1,GetNumAddOns() do
			local name,_,_,_,loadable = GetAddOnInfo(i);
			name = name:match("^MogIt_(.+)");
			if name and loadable then
				mog.addons[name] = mog.addons[name] or false;
			end
		end
		
		mog.LDBI:Register("MogIt",mog.mmb,mog.settings.minimap);
		mog.frame:UnregisterEvent("PLAYER_LOGIN");
	elseif event == "GET_ITEM_INFO_RECEIVED" then
		if mog.over and GameTooltip:GetOwner() == mog.over then
			mog.updateTooltip(mog.over);
		end
	end
end);
mog.frame:RegisterEvent("PLAYER_LOGIN");
mog.frame:RegisterEvent("GET_ITEM_INFO_RECEIVED");

SLASH_MOGIT1 = "/mog";
SLASH_MOGIT2 = "/mogit";
SlashCmdList["MOGIT"] = function()
	if mog.frame:IsShown() then
		HideUIPanel(mog.frame);
	else
		ShowUIPanel(mog.frame);
	end
end

mog.interface = CreateFrame("Frame");
mog.interface.title = mog.interface:CreateFontString(nil,"ARTWORK","GameFontNormalLarge");
mog.interface.title:SetPoint("TOPLEFT",16,-16 );
mog.interface.title:SetText("MogIt");
mog.interface.launch = CreateFrame("Button",nil,mog.interface,"UIPanelButtonTemplate");
mog.interface.launch:SetWidth(120);
mog.interface.launch:SetHeight(22);
mog.interface.launch:SetPoint("TOPLEFT",mog.interface.title,"BOTTOMLEFT",0,-8);
mog.interface.launch:SetText("Launch MogIt");
mog.interface.launch:SetScript("OnClick",function(self,btn)
	InterfaceOptionsFrame.lastFrame = nil;
	HideUIPanel(InterfaceOptionsFrame);
	ShowUIPanel(mog.frame);
end);
mog.interface.name = "MogIt";
InterfaceOptions_AddCategory(mog.interface);